require 'securerandom'

module Opera
  module AdMarvel
    class Impression

      include Opera::AdMarvel::Reportable

      attr_accessor :random, :user_id

      def random
        @random ||= SecureRandom.random_number(18446744073709551615)
      end

      # Override to add random and user_id:
      def attributes_with_payload_keys
        super.merge(
          { "cb" => random, "uid" => user_id }.select { |_, value| !value.nil? }
        )
      end

    end
  end
end
