module Opera
  module AdMarvel

    module Reportable

      extend ActiveSupport::Concern

      included do
        include ActiveModel::Model
        include ActiveModel::Serialization

        attr_accessor :partner_id, :site_id, :banner_id
      end

      def attributes_with_payload_keys
        {
          "pid" => partner_id, "sid" => site_id, "bid" => banner_id
        }.select { |_, value| !value.nil? }
      end

      def as_payload
        attributes_with_payload_keys.inject("") do |payload, keyval|
          "#{payload}__#{keyval.join('=')}"
        end
      end

      def save
        unless @already_saved

          collector_path = "/fam/" + case self.class.name.demodulize
          when "Impression" then "view_offline.php"
          when "Click" then "ck_offline.php"
          else raise "Not Implemented"
          end

          @already_saved = true
        end
      end

      module ClassMethods
        def create(given_attributes = {})
          reportable = self.new given_attributes
          reportable.save
          reportable
        end
        alias_method :report, :create
      end

    end

  end
end
