module Opera
  module AdMarvelSDK
    class Config

      include ActiveSupport::Configurable

      DEFAULT_API_URL = "http://ads.admarvel.com".freeze

      # API host:
      config_accessor :api_host do
        api_uri = URI(ENV.fetch "OPERA_AD_MARVEL_API_URL", DEFAULT_API_URL)
        api_uri.path = ""
        api_uri.to_s
      end

      # API path:
      config_accessor :api_path do
        api_uri = URI(ENV.fetch "OPERA_AD_MARVEL_API_URL", DEFAULT_API_URL)
        api_uri.path
      end

      # API Call Timeout:
      config_accessor :api_call_timeout do
        ENV.fetch("OPERA_AD_MARVEL_API_CALL_TIMEOUT", 15).to_i
      end

      # API Call Open Timeout:
      config_accessor :api_call_open_timeout do
        ENV.fetch("OPERA_AD_MARVEL_API_CALL_OPEN_TIMEOUT", 2).to_i
      end

      # Logger:
      config_accessor :logger do
        Logger.new($stdout)
      end

    end
  end
end
