require "active_model"

module Opera::MobileStore
  class BuildFile

    include ActiveModel::Model
    include ActiveModel::Serialization
    include Opera::MobileStore::InspectableAttributes

    # All attributes are Read-Only...
    attr_accessor :size, :url

    def attributes
      [:size, :url].inject({}) do |hash, field_name|
        field_value = self.public_send field_name
        hash[field_name.to_s] = field_value if field_value.present?
        hash
      end
    end

    def self.build_from_nokogiri_node(node)

      data = { url: node.text.strip }

      # Extract width + height data:
      file_size = node.xpath("string(@size)")
      data[:size] = file_size.to_i if file_size.present?

      self.new data
    end

    self.singleton_class.send :alias_method, :deserialize, :new

  end
end
