require "active_model"

module Opera::MobileStore
  class Category

    include ActiveModel::Model
    include ActiveModel::Serialization

    include Opera::MobileStore::InspectableAttributes

    include Opera::MobileStoreSDK::IdentityMapable

    # All attributes are Read-Only...
    attr_accessor :id, :code, :name

    def attributes
      [:id, :code, :name].inject({}) do |hash, field_name|
        field_value = self.public_send field_name
        hash[field_name.to_s] = field_value unless field_value.nil?
        hash
      end
    end

    self.singleton_class.send :alias_method, :deserialize, :new

  end
end
