require "active_model"

module Opera::MobileStore
  class ProductLocalization

    include ActiveModel::Model
    include ActiveModel::Serialization

    include Opera::MobileStore::InspectableAttributes

    # All attributes are Read-Only...
    attr_accessor :language_code,
                  :title,
                  :short_description,
                  :long_description

    def attributes
      [
        :language_code, :title, :short_description, :long_description
      ].inject({}) do |hash, field_name|
        field_value = self.public_send field_name
        hash[field_name.to_s] = field_value if field_value.present?
        hash
      end
    end

    self.singleton_class.send :alias_method, :deserialize, :new

  end
end
