require "active_support/concern"

module Opera
  module MobileStoreSDK
    module APIAccessible

      extend ActiveSupport::Concern

      included do

      end

      module ClassMethods

        def where(given_options = {})
          APIObjectList.new(name).where given_options
        end

        def per(given_item_count)
          APIObjectList.new(name).per given_item_count
        end

        def page(given_page)
          APIObjectList.new(name).page given_page
        end

        def all
          APIObjectList.new(name)
        end

        def includes(*included_fields)
          params = included_fields.map(&:to_s).map(&:downcase)
          .select { |x| %w(original_images billing eula adult subsites compatibility profit rating).include? x }
          .map { |x| x == "billing" ? "show_billing" : x }
          .inject({}) { |hash, param_name| hash[param_name] = "1"; hash }

          APIObjectList.new name, params
        end

      end

    end
  end
end
