module Opera
  module MobileStoreSDK
    class Config

      include ActiveSupport::Configurable

      DEFAULT_API_URL = "https://publishers.apps.opera.com/administrator/mng_contpartners/export_partner_software.php".freeze

      config_accessor :username do
        ENV.fetch "OPERA_MOBILE_STORE_USERNAME", nil
      end

      config_accessor :password do
        ENV.fetch "OPERA_MOBILE_STORE_PASSWORD", nil
      end

      # API host:
      config_accessor :api_host do
        api_uri = URI(ENV.fetch "OPERA_MOBILE_STORE_API_URL", DEFAULT_API_URL)
        api_uri.path = ""
        api_uri.to_s
      end

      # API path:
      config_accessor :api_path do
        api_uri = URI(ENV.fetch "OPERA_MOBILE_STORE_API_URL", DEFAULT_API_URL)
        api_uri.path
      end

      # API Call Timeout:
      config_accessor :api_call_timeout do
        ENV.fetch("OPERA_MOBILE_STORE_API_CALL_TIMEOUT", 15).to_i
      end

      # API Call Open Timeout:
      config_accessor :api_call_open_timeout do
        ENV.fetch("OPERA_MOBILE_STORE_API_CALL_OPEN_TIMEOUT", 2).to_i
      end

      # Logger:
      config_accessor :logger do
        Logger.new($stdout)
      end

      # Authentication method:
      config_accessor :authentication do
        if ENV["OPERA_MOBILE_STORE_AUTH"].present?
          ENV["OPERA_MOBILE_STORE_AUTH"].to_sym
        else
          :password
        end
      end

      protected

        # def auto_conf
        #   # Cargar configuracion dentro del folder de config en Rails:
        #   if defined?(Rails)
        #     yml_path = File.join(Rails.root, 'config', 'narai.yml')
        #     load_config_from_yml(yml_path, Rails.env)
        #
        #     # Use the Rails logger:
        #     @logger = Rails.logger
        #   elsif File.exists?('./narai.yml')
        #     load_config_from_yml('./narai.yml')
        #   end
        # end

    end
  end
end
